package ${basePackage}.module.system.mgr;

import ${basePackage}.frame.base.Token;
import ${basePackage}.module.system.req.*;
import ${basePackage}.module.system.rsp.*;

/**
 * 字典
 *
 * @author wangbing
 * @version 0.0.1
 * @since 2017-01-01
 */
public interface DictManager {

    /**
     * 插入
     *
     * @param request 请求对象
     * @param token   令牌
     * @return
     */
    DictCreateResponse create(DictCreateRequest request, Token token);

    /**
     * 逻辑删除
     *
     * @param request 请求对象
     * @param token   令牌
     * @return
     */
    DictDeleteResponse delete(DictDeleteRequest request, Token token);

    /**
     * 更新
     *
     * @param request 请求对象
     * @param token   令牌
     * @return
     */
    DictUpdateResponse update(DictUpdateRequest request, Token token);

    /**
     * 查询
     *
     * @param request 请求对象
     * @param token   令牌
     * @return
     */
    DictFindResponse find(DictFindRequest request, Token token);

    /**
     * 获得对象
     *
     * @param request 请求对象
     * @param token   令牌
     * @return
     */
    DictGetResponse get(DictGetRequest request, Token token);

    /**
     * 加载字典
     *
     * @param request 请求对象
     * @param token   令牌
     * @return
     */
    DictLoadResponse load(DictLoadRequest request, Token token);
}
