<div id="app" v-cloak>
    <el-card class="box-card search">
        <el-form :inline="true" :model="vm" ref="vm" label-position="left" label-width="90px">
            <el-form-item label="字典名称" prop="dictName">
                <el-input v-model="vm.dictName" clearable size="small" placeholder="请输入字典名称" readonly></el-input>
            </el-form-item>
            <el-form-item label="字典键" prop="key">
                <el-input v-model="vm.key" clearable size="small" placeholder="请输入字典键"></el-input>
            </el-form-item>
            <el-form-item label="字典值" prop="value">
                <el-input v-model="vm.value" clearable size="small" placeholder="请输入字典值"></el-input>
            </el-form-item>
            <el-form-item label="是否有效" prop="valid">
                <el-radio-group v-model="vm.valid" clearable>
                    <el-radio :label="true">是</el-radio>
                    <el-radio :label="false">否</el-radio>
                </el-radio-group>
            </el-form-item>
            <el-form-item>
                <el-button type="primary" size="small" icon="el-icon-search" @click="onSearch">搜索</el-button>
                <el-button type="warning" size="small" icon="el-icon-refresh-left" @click="onReset('vm')">重置</el-button>
            </el-form-item>
        </el-form>
    </el-card>

    <el-card class="box-card">
        <el-row>
            <el-col :span="12">
                <el-button type="success" size="small" icon="el-icon-plus" @click="onCreate">新增</el-button>

                <el-button type="warning" size="small" icon="el-icon-download" @click="onExport">导出</el-button>

                <el-dialog class="form" :title="form.title" :visible.sync="form.dialog">
                    <el-form :model="form" :inline="true" :rules="formRules" ref="form" label-position="left"
                             label-width="90px">
                        <el-form-item label="字典键" prop="key">
                            <el-input v-model="form.key" clearable size="small" placeholder="请输入字典键"></el-input>
                        </el-form-item>
                        <el-form-item label="字典值" prop="value">
                            <el-input v-model="form.value" clearable size="small" placeholder="请输入字典值"></el-input>
                        </el-form-item>
                        <el-form-item label="排序值" prop="sort">
                            <el-input-number size="small" v-model="form.sort" :min="1" :max="10000"
                                             label="描述文字"></el-input-number>
                        </el-form-item>
                        <el-form-item label="是否有效" prop="valid">
                            <el-radio-group v-model="form.valid" clearable>
                                <el-radio :label="true">是</el-radio>
                                <el-radio :label="false">否</el-radio>
                            </el-radio-group>
                        </el-form-item>
                    </el-form>
                    <span slot="footer" class="dialog-footer">
                        <el-button size="small" @click="form.dialog = false">取消</el-button>
                        <el-button size="small" type="primary" @click="onSave">保存</el-button>
                    </span>
                </el-dialog>
            </el-col>

            <el-col :span="12">
                <el-button-group style="float: right;">
                    <el-tooltip effect="dark" content="Excel模板下载" placement="bottom">
                        <el-button size="small" icon="el-icon-date" @click="onTemplate"></el-button>
                    </el-tooltip>

                    <el-tooltip effect="dark" content="Excel导入" placement="bottom">
                        <el-button size="small" class="el-icon-upload2" @click="onImport"></el-button>
                    </el-tooltip>

                    <el-tooltip effect="dark" content="批量删除" placement="bottom">
                        <el-button size="small" icon="el-icon-delete" @click="onBitchDelete"></el-button>
                    </el-tooltip>

                    <el-tooltip effect="dark" content="刷新" placement="bottom">
                        <el-button size="small" icon="el-icon-refresh" @click="onFind"></el-button>
                    </el-tooltip>
                </el-button-group>
            </el-col>
        </el-row>

        <el-table
                @selection-change="onSelectionChange"
                empty-text="无数据"
                :data="result"
                size="small"
                style="width: 100%">
            <el-table-column
                    align="center"
                    type="selection"
                    width="40">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="id"
                    label="主键"
                    width="140">
            </el-table-column>
            <el-table-column
                    align="center"
                    width="80"
                    label="是否有效">
                <template slot-scope="scope">
                    <el-tag size="mini" v-if="scope.row.valid">有效</el-tag>
                    <el-tag size="mini" type="danger" v-if="!scope.row.valid">无效</el-tag>
                </template>
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="key"
                    label="字典键">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="value"
                    label="字典值">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="sort"
                    label="排序">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="createTime"
                    label="创建时间">
            </el-table-column>
            <el-table-column
                    align="center"
                    fixed="right"
                    width="120"
                    label="操作">
                <template slot-scope="scope">
                    <el-dropdown size="mini" split-button type="primary" @click="onCommand(['edit',scope.row])"
                                 @command="onCommand">
                        <i class="el-icon-edit"></i>编辑
                        <el-dropdown-menu slot="dropdown">
                            <el-dropdown-item :command="['delete',scope.row]" icon="el-icon-delete">删除
                            </el-dropdown-item>
                        </el-dropdown-menu>
                    </el-dropdown>
                </template>
            </el-table-column>
        </el-table>

        <el-pagination
                background
                v-if="vm.totalCount > vm.pageSize"
                style="margin-top: 10px"
                @current-change="onPage"
                :current-page="vm.pageNumber"
                :page-size="vm.pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="vm.totalCount">
        </el-pagination>
    </el-card>
</div>
<script>
    var app = new Vue({
        mixins: [mixin],
        el: "#app",
        data: {
            module: 'system',
            target: 'dictItem',
            vm: {
                dictName: location.getParam("dictName"),
                key: '',
                value: '',
                valid: '',
                pageNumber: 1,
                pageSize: 10,
                totalCount: 0,
                sortKey: 'CREATE_TIME',
                sortType: 'DESC'
            },
            form: {
                title: "",
                dialog: false,
                id: '',
                dictName: '',
                key: '',
                value: '',
                sort: 0,
                valid: true,
                rowVersion: ""
            },
            formRules: {
                key: [
                    {required: true, message: '请输入字典名称', trigger: 'blur'},
                    {min: 1, max: 50, message: '长度在 3 到 5 个字符', trigger: 'blur'}
                ],
                value: [
                    {required: true, message: '请输入字典代码', trigger: 'blur'},
                    {min: 1, max: 50, message: '长度在 1 到 50 个字符', trigger: 'blur'}
                ],
                sort: [
                    {required: true, message: '排序不能为空', trigger: 'blur'},
                ],
                valid: [
                    {required: true, message: '是否有效不能为空', trigger: 'blur'},
                ],
            },
        },
        methods: {
            onCreate: function () {
                this.form.title = '新增字典项';
                this.form.dialog = true;
                this.form.dictName = location.getParam("dictName");
                this.form.key = '';
                this.form.value = '';
                this.form.sort = this.vm.totalCount + 1;
                this.form.valid = true;
            },
            onCommand: function (arg) {
                const cmd = arg[0];
                const item = arg[1];
                switch (cmd) {
                    case "edit":
                        this.form.title = '字典项编辑';
                        this.form.dialog = true;
                        this.form.id = item.id;
                        this.form.dictName = item.dictName;
                        this.form.key = item.key;
                        this.form.value = item.value;
                        this.form.sort = item.sort;
                        this.form.valid = item.valid;
                        this.form.rowVersion = item.rowVersion;
                        break;
                    case "delete":
                        this.onDelete(item);
                        break;
                    default:
                        this.w("未找到对应的命令");
                        break;
                }
            }
        },
        mounted: function () {
            this.onFind();
        }
    })
</script>
